Whamcloud - gitweb
LU-14789 tests: make sanity 133f and 133g working
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 625bc80..744e6d6 100755 (executable)
@@ -77,8 +77,8 @@ if (( $LINUX_VERSION_CODE >= $(version_code 4.18.0) &&
        ALWAYS_EXCEPT+=" 411"
 fi
 
-#                                  5          12     8   12  (min)"
-[ "$SLOW" = "no" ] && EXCEPT_SLOW="27m 64b 68 71 115 135 136 300o"
+#                                  5              12     8   12  (min)"
+[ "$SLOW" = "no" ] && EXCEPT_SLOW="27m 60i 64b 68 71 115 135 136 300o"
 
 if [ "$mds1_FSTYPE" = "zfs" ]; then
        # bug number for skipped test:
@@ -92,6 +92,8 @@ if [ "$ost1_FSTYPE" = "zfs" ]; then
        ALWAYS_EXCEPT+="                130a 130b 130c 130d 130e 130f 130g"
 fi
 
+proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
+
 # Get the SLES distro version
 #
 # Returns a version string that should only be used in comparing
@@ -162,7 +164,7 @@ check_and_setup_lustre
 DIR=${DIR:-$MOUNT}
 assert_DIR
 
-MAXFREE=${MAXFREE:-$((200000 * $OSTCOUNT))}
+MAXFREE=${MAXFREE:-$((300000 * $OSTCOUNT))}
 
 [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
 [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
@@ -1835,7 +1837,7 @@ __exhaust_precreations() {
        local FAILIDX=${3:-$OSTIDX}
        local ofacet=ost$((OSTIDX + 1))
 
-       test_mkdir -p -c1 $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        local mdtidx=$($LFS getstripe -m $DIR/$tdir)
        local mfacet=mds$((mdtidx + 1))
        echo OSTIDX=$OSTIDX MDTIDX=$mdtidx
@@ -1991,7 +1993,7 @@ test_27q() {
        reset_enospc
        rm -f $DIR/$tdir/$tfile
 
-       test_mkdir $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        $MCREATE $DIR/$tdir/$tfile || error "mcreate $DIR/$tdir/$tfile failed"
        $TRUNCATE $DIR/$tdir/$tfile 80000000 ||
                error "truncate $DIR/$tdir/$tfile failed"
@@ -2755,7 +2757,8 @@ test_27I() {
        save_layout_restore_at_exit $MOUNT
        $LFS setstripe -c 2 -i 0 $MOUNT
        pool_add $pool || error "pool_add failed"
-       pool_add_targets $pool $ostrange || "pool_add_targets failed"
+       pool_add_targets $pool $ostrange ||
+               error "pool_add_targets failed"
        test_mkdir $DIR/$tdir
        $LFS setstripe -p $pool $DIR/$tdir
        $MULTIOP $DIR/$tdir/$tfile Oc || error "multiop failed"
@@ -3321,6 +3324,7 @@ run_test 27P "basic ops on foreign dir of foreign_symlink type"
 
 test_27Q() {
        rm -f $TMP/$tfile $TMP/$tfile.loop $TMP/$tfile.none $TMP/$tfile.broken
+       stack_trap "rm -f $TMP/$tfile*"
 
        test_mkdir $DIR/$tdir-1
        test_mkdir $DIR/$tdir-2
@@ -4765,7 +4769,7 @@ test_39l() {
        local atime_diff=$(do_facet $SINGLEMDS \
                                lctl get_param -n mdd.*MDT0000*.atime_diff)
        rm -rf $DIR/$tdir
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
 
        # test setting directory atime to future
        touch -a -d @$TEST_39_ATIME $DIR/$tdir
@@ -5557,7 +5561,7 @@ test_51b() {
        # cleanup the directory
        rm -fr $dir
 
-       test_mkdir -c1 $dir
+       mkdir_on_mdt -i $((RANDOM % MDSCOUNT)) $dir
 
        $LFS df
        $LFS df -i
@@ -6664,6 +6668,36 @@ test_56rb() {
 }
 run_test 56rb "check lfs find --size --ost/--mdt works"
 
+test_56rc() {
+       (( MDSCOUNT >= 2 )) || skip "needs at least 2 MDTs"
+       local dir=$DIR/$tdir
+       local found
+
+       test_mkdir -c 2 -H all_char $dir || error "failed to mkdir $dir"
+       $LFS mkdir -c 2 --mdt-hash all_char $dir/$tdir-all{1..10}
+       (( $MDSCOUNT > 2 )) &&
+               $LFS mkdir -c 3 --mdt-hash fnv_1a_64 $dir/$tdir-fnv{1..10}
+       mkdir $dir/$tdir-{1..10}
+       touch $dir/$tfile-{1..10}
+
+       found=$($LFS find $dir --mdt-count 2 | wc -l)
+       expect=11
+       (( $found == $expect )) || error "found $found 2-stripe, expect $expect"
+
+       found=$($LFS find $dir -T +1 | wc -l)
+       (( $MDSCOUNT > 2 )) && expect=$((expect + 10))
+       (( $found == $expect )) || error "found $found 2+stripe, expect $expect"
+
+       found=$($LFS find $dir --mdt-hash all_char | wc -l)
+       expect=11
+       (( $found == $expect )) || error "found $found all_char, expect $expect"
+
+       found=$($LFS find $dir --mdt-hash fnv_1a_64 | wc -l)
+       (( $MDSCOUNT > 2 )) && expect=10 || expect=0
+       (( $found == $expect )) || error "found $found all_char, expect $expect"
+}
+run_test 56rc "check lfs find --mdt-count/--mdt-hash works"
+
 test_56s() { # LU-611 #LU-9369
        [[ $OSTCOUNT -lt 2 ]] && skip_env "need at least 2 OSTs"
 
@@ -8267,6 +8301,34 @@ test_60h() {
 }
 run_test 60h "striped directory with missing stripes can be accessed"
 
+function t60i_load() {
+       mkdir $DIR/$tdir
+       #define OBD_FAIL_LLOG_PAUSE_AFTER_PAD               0x131c
+       $LCTL set_param fail_loc=0x131c fail_val=1
+       for ((i=0; i<5000; i++)); do
+               touch $DIR/$tdir/f$i
+       done
+}
+
+test_60i() {
+       changelog_register || error "changelog_register failed"
+       local cl_user="${CL_USERS[$SINGLEMDS]%% *}"
+       changelog_users $SINGLEMDS | grep -q $cl_user ||
+               error "User $cl_user not found in changelog_users"
+       changelog_chmask "ALL"
+       t60i_load &
+       local PID=$!
+       for((i=0; i<100; i++)); do
+               changelog_dump >/dev/null ||
+                       error "can't read changelog"
+       done
+       kill $PID
+       wait $PID
+       changelog_deregister || error "changelog_deregister failed"
+       $LCTL set_param fail_loc=0
+}
+run_test 60i "llog: new record vs reader race"
+
 test_61a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
@@ -8820,8 +8882,7 @@ test_65n() {
        which getfattr > /dev/null 2>&1 || skip_env "no getfattr command"
        which setfattr > /dev/null 2>&1 || skip_env "no setfattr command"
 
-       local root_layout=$(save_layout $MOUNT)
-       stack_trap "restore_layout $MOUNT $root_layout" EXIT
+       save_layout_restore_at_exit $MOUNT
 
        # new subdirectory under root directory should not inherit
        # the default layout from root
@@ -9390,6 +9451,7 @@ test_77d() { # bug 10889
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
        $GSS && skip_env "could not run with gss"
 
+       stack_trap "rm -f $DIR/$tfile"
        #define OBD_FAIL_OSC_CHECKSUM_SEND       0x409
        $LCTL set_param fail_loc=0x80000409
        set_checksums 1
@@ -9414,6 +9476,7 @@ test_77f() { # bug 10889
        $GSS && skip_env "could not run with gss"
 
        set_checksums 1
+       stack_trap "rm -f $DIR/$tfile"
        for algo in $CKSUM_TYPES; do
                cancel_lru_locks osc
                set_checksum_type $algo
@@ -9535,6 +9598,20 @@ run_test 77l "preferred checksum type is remembered after reconnected"
 rm -f $F77_TMP
 unset F77_TMP
 
+test_77m() {
+       (( $CLIENT_VERSION >= $(version_code 2.14.52) )) ||
+               skip "Need at least version 2.14.52"
+       local param=checksum_speed
+
+       $LCTL get_param $param || error "reading $param failed"
+
+       csum_speeds=$($LCTL get_param -n $param)
+
+       [[ "$csum_speeds" =~ "adler32" && "$csum_speeds" =~ "crc32" ]] ||
+               error "known checksum types are missing"
+}
+run_test 77m "Verify checksum_speed is correctly read"
+
 cleanup_test_78() {
        trap 0
        rm -f $DIR/$tfile
@@ -13757,8 +13834,12 @@ test_133f() {
        $LCTL get_param -R '*' &> /dev/null
 
        # Verifing writability with badarea_io.
+       local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
+       local skipped_params='force_lbug|changelog_mask|daemon_file'
        $LCTL list_param -FR '*' | grep '=' | tr -d = |
-               egrep -v 'force_lbug|changelog_mask' | xargs badarea_io ||
+               egrep -v "$skipped_params" |
+               xargs -n 1 find $proc_dirs -name |
+               xargs -n 1 badarea_io ||
                error "client badarea_io failed"
 
        # remount the FS in case writes/reads /proc break the FS
@@ -13771,6 +13852,8 @@ test_133g() {
        remote_mds_nodsh && skip "remote MDS with nodsh"
        remote_ost_nodsh && skip "remote OST with nodsh"
 
+       local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
+       local skipped_params="'force_lbug|changelog_mask|daemon_file'"
        local facet
        for facet in mds1 ost1; do
                local facet_ver=$(lustre_version_code $facet)
@@ -13781,8 +13864,9 @@ test_133g() {
                fi
                if [ $facet_ver -ge $(version_code 2.5.54) ]; then
                        do_facet $facet "$LCTL list_param -FR '*' | grep '=' |
-                               tr -d = | egrep -v 'force_lbug|changelog_mask' |
-                               xargs badarea_io" ||
+                               tr -d = | egrep -v $skipped_params |
+                               xargs -n 1 find $proc_dirs -name |
+                               xargs -n 1 badarea_io" ||
                                        error "$facet badarea_io failed"
                else
                        skip_noexit "$facet: too old lustre for get_param -R"
@@ -13826,7 +13910,7 @@ test_134a() {
        [[ $MDS1_VERSION -lt $(version_code 2.7.54) ]] &&
                skip "Need MDS version at least 2.7.54"
 
-       mkdir -p $DIR/$tdir || error "failed to create $DIR/$tdir"
+       mkdir_on_mdt0 $DIR/$tdir || error "failed to create $DIR/$tdir"
        cancel_lru_locks mdc
 
        local nsdir="ldlm.namespaces.*-MDT0000-mdc-*"
@@ -13862,7 +13946,7 @@ test_134b() {
        [[ $MDS1_VERSION -lt $(version_code 2.7.54) ]] &&
                skip "Need MDS version at least 2.7.54"
 
-       mkdir -p $DIR/$tdir || error "failed to create $DIR/$tdir"
+       mkdir_on_mdt0 $DIR/$tdir || error "failed to create $DIR/$tdir"
        cancel_lru_locks mdc
 
        local low_wm=$(do_facet mds1 $LCTL get_param -n \
@@ -14790,35 +14874,35 @@ test_154f() {
        [ -n "$FILESET" ] && skip "SKIP due to FILESET set"
 
        # create parent directory on a single MDT to avoid cross-MDT hardlinks
-       test_mkdir -p -c1 $DIR/$tdir/d
+       mkdir_on_mdt0 $DIR/$tdir
        # test dirs inherit from its stripe
-       mkdir -p $DIR/$tdir/d/foo1 || error "mkdir error"
-       mkdir -p $DIR/$tdir/d/foo2 || error "mkdir error"
-       cp /etc/hosts $DIR/$tdir/d/foo1/$tfile
-       ln $DIR/$tdir/d/foo1/$tfile $DIR/$tdir/d/foo2/link
+       mkdir -p $DIR/$tdir/foo1 || error "mkdir error"
+       mkdir -p $DIR/$tdir/foo2 || error "mkdir error"
+       cp /etc/hosts $DIR/$tdir/foo1/$tfile
+       ln $DIR/$tdir/foo1/$tfile $DIR/$tdir/foo2/link
        touch $DIR/f
 
        # get fid of parents
-       local FID0=$($LFS path2fid $DIR/$tdir/d)
-       local FID1=$($LFS path2fid $DIR/$tdir/d/foo1)
-       local FID2=$($LFS path2fid $DIR/$tdir/d/foo2)
+       local FID0=$($LFS path2fid $DIR/$tdir)
+       local FID1=$($LFS path2fid $DIR/$tdir/foo1)
+       local FID2=$($LFS path2fid $DIR/$tdir/foo2)
        local FID3=$($LFS path2fid $DIR)
 
        # check that path2fid --parents returns expected <parent_fid>/name
        # 1) test for a directory (single parent)
-       local parent=$($LFS path2fid --parents $DIR/$tdir/d/foo1)
+       local parent=$($LFS path2fid --parents $DIR/$tdir/foo1)
        [ "$parent" == "$FID0/foo1" ] ||
                error "expected parent: $FID0/foo1, got: $parent"
 
        # 2) test for a file with nlink > 1 (multiple parents)
-       parent=$($LFS path2fid --parents $DIR/$tdir/d/foo1/$tfile)
+       parent=$($LFS path2fid --parents $DIR/$tdir/foo1/$tfile)
        echo "$parent" | grep -F "$FID1/$tfile" ||
                error "$FID1/$tfile not returned in parent list"
        echo "$parent" | grep -F "$FID2/link" ||
                error "$FID2/link not returned in parent list"
 
        # 3) get parent by fid
-       local file_fid=$($LFS path2fid $DIR/$tdir/d/foo1/$tfile)
+       local file_fid=$($LFS path2fid $DIR/$tdir/foo1/$tfile)
        parent=$($LFS path2fid --parents $MOUNT/.lustre/fid/$file_fid)
        echo "$parent" | grep -F "$FID1/$tfile" ||
                error "$FID1/$tfile not returned in parent list (by fid)"
@@ -14840,7 +14924,7 @@ test_154f() {
        lctl set_param llite.*.xattr_cache 1
 
        # 6.1) linkea update on rename
-       mv $DIR/$tdir/d/foo1/$tfile $DIR/$tdir/d/foo2/$tfile.moved
+       mv $DIR/$tdir/foo1/$tfile $DIR/$tdir/foo2/$tfile.moved
 
        # get parents by fid
        parent=$($LFS path2fid --parents $MOUNT/.lustre/fid/$file_fid)
@@ -14852,7 +14936,7 @@ test_154f() {
                error "$FID2/$tfile.moved is not in parent list"
 
        # 6.2) linkea update on unlink
-       rm -f $DIR/$tdir/d/foo2/link
+       rm -f $DIR/$tdir/foo2/link
        parent=$($LFS path2fid --parents $MOUNT/.lustre/fid/$file_fid)
        # foo2/link should no longer be returned in parent list
        echo "$parent" | grep -F "$FID2/link" &&
@@ -14872,7 +14956,7 @@ test_154g()
           $CLIENT_VERSION -gt $(version_code 2.6.99) ]] ||
                skip "Need MDS version at least 2.6.92"
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        llapi_fid_test -d $DIR/$tdir
 }
 run_test 154g "various llapi FID tests"
@@ -15223,6 +15307,8 @@ test_160a() {
        changelog_users $SINGLEMDS | grep -q $cl_user ||
                error "User $cl_user not found in changelog_users"
 
+       mkdir_on_mdt0 $DIR/$tdir
+
        # change something
        test_mkdir -p $DIR/$tdir/pics/2008/zachy
        changelog_clear 0 || error "changelog_clear failed"
@@ -15233,8 +15319,6 @@ test_160a() {
        ln -s $DIR/$tdir/pics/2008/portland.jpg $DIR/$tdir/pics/desktop.jpg
        rm $DIR/$tdir/pics/desktop.jpg
 
-       changelog_dump | tail -10
-
        echo "verifying changelog mask"
        changelog_chmask "-MKDIR"
        changelog_chmask "-CLOSE"
@@ -15248,7 +15332,6 @@ test_160a() {
        test_mkdir -p $DIR/$tdir/pics/2008/sofia                # mkdir 1
        echo "zzzzzz" > $DIR/$tdir/pics/zach/file               # open 3
 
-       changelog_dump | tail -10
        MKDIRS=$(changelog_dump | grep -c "MKDIR")
        CLOSES=$(changelog_dump | grep -c "CLOSE")
        [ $MKDIRS -eq 1 ] || error "MKDIR changelog mask count $MKDIRS != 1"
@@ -15311,10 +15394,10 @@ test_160a() {
                error "User '$cl_user' still in changelog_users"
 
        # lctl get_param -n mdd.*.changelog_users
-       # current index: 144
+       # current_index: 144
        # ID    index (idle seconds)
-       # cl3   144 (2)
-       if ! changelog_users $SINGLEMDS | grep "^cl"; then
+       # cl3   144   (2) mask=<list>
+       if [ -z "$(changelog_users $SINGLEMDS | grep -v current.index)" ]; then
                # this is the normal case where all users were deregistered
                # make sure no new records are added when no users are present
                local last_rec1=$(changelog_users $SINGLEMDS |
@@ -16133,6 +16216,107 @@ test_160n() {
 }
 run_test 160n "Changelog destroy race"
 
+test_160o() {
+       local mdt="$(facet_svc $SINGLEMDS)"
+
+       [[ $PARALLEL != "yes" ]] || skip "skip parallel run"
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [ $MDS1_VERSION -ge $(version_code 2.14.52) ] ||
+               skip "Need MDS version at least 2.14.52"
+
+       changelog_register --user test_160o -m unlnk+close+open ||
+               error "changelog_register failed"
+       # drop server mask so it doesn't interfere
+       do_facet $SINGLEMDS $LCTL --device $mdt \
+                               changelog_register -u "Tt3_-#" &&
+               error "bad symbols in name should fail"
+
+       do_facet $SINGLEMDS $LCTL --device $mdt \
+                               changelog_register -u test_160o &&
+               error "the same name registration should fail"
+
+       do_facet $SINGLEMDS $LCTL --device $mdt \
+                       changelog_register -u test_160toolongname &&
+               error "too long name registration should fail"
+
+       changelog_chmask "MARK+HSM"
+       lctl get_param mdd.*.changelog*mask
+       local cl_user="${CL_USERS[$SINGLEMDS]%% *}"
+       changelog_users $SINGLEMDS | grep -q $cl_user ||
+               error "User $cl_user not found in changelog_users"
+       #verify username
+       echo $cl_user | grep -q test_160o ||
+               error "User $cl_user has no specific name 'test160o'"
+
+       # change something
+       changelog_clear 0 || error "changelog_clear failed"
+       # generate some changelog records to accumulate on MDT0
+       test_mkdir -p -i0 -c1 $DIR/$tdir || error "test_mkdir $tdir failed"
+       touch $DIR/$tdir/$tfile                 # open 1
+
+       OPENS=$(changelog_dump | grep -c "OPEN")
+       [[ $OPENS -eq 1 ]] || error "OPEN changelog mask count $OPENS != 1"
+
+       # must be no MKDIR it wasn't set as user mask
+       MKDIR=$(changelog_dump | grep -c "MKDIR")
+       [[ $MKDIR -eq 0 ]] || error "MKDIR changelog mask found $MKDIR > 0"
+
+       oldmask=$(do_facet $SINGLEMDS $LCTL get_param \
+                               mdd.$mdt.changelog_current_mask -n)
+       # register maskless user
+       changelog_register || error "changelog_register failed"
+       # effective mask should be not changed because it is not minimal
+       mask=$(do_facet $SINGLEMDS $LCTL get_param \
+                               mdd.$mdt.changelog_current_mask -n)
+       [[ $mask == $oldmask ]] || error "mask was changed: $mask vs $oldmask"
+       # set server mask to minimal value
+       changelog_chmask "MARK"
+       # check effective mask again, should be treated as DEFMASK now
+       mask=$(do_facet $SINGLEMDS $LCTL get_param \
+                               mdd.$mdt.changelog_current_mask -n)
+       [[ $mask == *"HLINK"* ]] || error "mask is not DEFMASK as expected"
+
+       do_facet $SINGLEMDS $LCTL --device $mdt \
+                               changelog_deregister -u test_160o ||
+               error "cannot deregister by name"
+}
+run_test 160o "changelog user name and mask"
+
+test_160p() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       [[ $MDS1_VERSION -ge $(version_code 2.14.51) ]] ||
+               skip "Need MDS version at least 2.14.51"
+       [[ "$mds1_FSTYPE" == "ldiskfs" ]] || skip "ldiskfs only test"
+       local cl_users
+       local cl_user1
+       local entry_count
+
+       # Create a user
+       changelog_register || error "first changelog_register failed"
+
+       cl_users=(${CL_USERS[mds1]})
+       cl_user1="${cl_users[0]}"
+
+       test_mkdir -p -i0 -c1 $DIR/$tdir || error "test_mkdir $tdir failed"
+       createmany -m $DIR/$tdir/$tfile 50 ||
+               error "create $DIR/$tdir/$tfile failed"
+       unlinkmany $DIR/$tdir/$tfile 50 || error "unlinkmany failed"
+       rm -rf $DIR/$tdir
+
+       # check changelogs have been generated
+       entry_count=$(changelog_dump | wc -l)
+       ((entry_count != 0)) || error "no changelog entries found"
+
+       # remove changelog_users and check that orphan entries are removed
+       stop mds1
+       do_facet mds1 "$DEBUGFS -w -R 'rm changelog_users' $(mdsdevname 1)"
+       start mds1 || error "cannot start mdt"
+       entry_count=$(changelog_dump | wc -l)
+       ((entry_count == 0)) ||
+               error "found $entry_count changelog entries, expected none"
+}
+run_test 160p "Changelog orphan cleanup with no users"
+
 test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
@@ -17094,7 +17278,7 @@ test_183() { # LU-2275
        [[ $MDS1_VERSION -lt $(version_code 2.3.56) ]] &&
                skip "Need MDS version at least 2.3.56"
 
-       mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
+       mkdir_on_mdt0 $DIR/$tdir || error "creating dir $DIR/$tdir"
        echo aaa > $DIR/$tdir/$tfile
 
 #define OBD_FAIL_MDS_NEGATIVE_POSITIVE  0x148
@@ -17686,7 +17870,7 @@ test_205a() { # Job stats
 
        local cmd
        # mkdir
-       cmd="mkdir $DIR/$tdir"
+       cmd="$LFS mkdir -i 0 -c 1 $DIR/$tdir"
        verify_jobstats "$cmd" "$SINGLEMDS"
        # rmdir
        cmd="rmdir $DIR/$tdir"
@@ -17727,7 +17911,7 @@ test_205a() { # Job stats
        [ $left -ge 0 ] && wait_update_facet $SINGLEMDS \
                "lctl get_param *.*.job_stats | grep -c 'job_id.*mkdir'" \
                        "0" $left
-       cmd="mkdir $DIR/$tdir.expire"
+       cmd="$LFS mkdir -i 0 -c 1 $DIR/$tdir.expire"
        verify_jobstats "$cmd" "$SINGLEMDS"
        [ $(do_facet $SINGLEMDS lctl get_param *.*.job_stats |
            grep -c "job_id.*mkdir") -gt 1 ] && error "old jobstats not expired"
@@ -17780,6 +17964,9 @@ run_test 205a "Verify job stats"
 
 # LU-13117, LU-13597
 test_205b() {
+       (( $MDS1_VERSION >= $(version_code 2.13.54.91) )) ||
+               skip "Need MDS version at least 2.13.54.91"
+
        job_stats="mdt.*.job_stats"
        $LCTL set_param $job_stats=clear
        # Setting jobid_var to USER might not be supported
@@ -18218,7 +18405,7 @@ test_220() { #LU-325
        local OSTIDX=0
 
        # create on MDT0000 so the last_id and next_id are correct
-       mkdir $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        local OST=$($LFS df $DIR | awk '/OST:'$OSTIDX'/ { print $1 }')
        OST=${OST%_UUID}
 
@@ -19098,7 +19285,7 @@ test_230e() {
        local a_fid
        local b_fid
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        mkdir $DIR/$tdir/migrate_dir
        mkdir $DIR/$tdir/other_dir
        touch $DIR/$tdir/migrate_dir/a
@@ -19435,15 +19622,15 @@ test_230o() {
 run_test 230o "dir split"
 
 test_230p() {
-       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
-       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+       (( MDSCOUNT > 1 )) || skip "needs >= 2 MDTs"
+       (( MDS1_VERSION >= $(version_code 2.13.52) )) ||
                skip "Need MDS version at least 2.13.52"
 
        local mdts=$(comma_list $(mdts_nodes))
        local timeout=100
        local restripe_status
        local delta
-       local i
+       local c
 
        [[ $mds1_FSTYPE == zfs ]] && timeout=300
 
@@ -19457,33 +19644,37 @@ test_230p() {
 
        test_mkdir -c $MDSCOUNT -H crush $DIR/$tdir
        createmany -m $DIR/$tdir/f 100 ||
-               error "create files under remote dir failed $i"
+               error "create files under remote dir failed"
        createmany -d $DIR/$tdir/d 100 ||
-               error "create dirs under remote dir failed $i"
+               error "create dirs under remote dir failed"
 
-       for i in $(seq $((MDSCOUNT - 1)) -1 1); do
+       for c in $(seq $((MDSCOUNT - 1)) -1 1); do
                local mdt_hash="crush"
 
                do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear >/dev/null"
-               $LFS setdirstripe -c $i $DIR/$tdir ||
-                       error "split -c $i $tdir failed"
-               [ $i -eq 1 ] && mdt_hash="none"
+               $LFS setdirstripe -c $c $DIR/$tdir ||
+                       error "split -c $c $tdir failed"
+               if (( MDS1_VERSION >= $(version_code 2.14.51) )); then
+                       mdt_hash="$mdt_hash,fixed"
+               elif [ $c -eq 1 ]; then
+                       mdt_hash="none"
+               fi
                wait_update $HOSTNAME \
                        "$LFS getdirstripe -H $DIR/$tdir" $mdt_hash $timeout ||
                        error "dir merge not finished"
                delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
                        awk '/migrate/ {sum += $2} END { print sum }')
-               echo "$delta migrated when dir merge $((i + 1)) to $i stripes"
+               echo "$delta migrated when dir merge $((c + 1)) to $c stripes"
                # delta is around total_files/stripe_count
-               (( $delta < 200 / i + 4 )) ||
-                       error "$delta files migrated >= $((200 / i + 4))"
+               (( delta < 200 / c + 4 )) ||
+                       error "$delta files migrated >= $((200 / c + 4))"
        done
 }
 run_test 230p "dir merge"
 
 test_230q() {
-       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
-       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+       (( MDSCOUNT > 1)) || skip "needs >= 2 MDTs"
+       (( MDS1_VERSION >= $(version_code 2.13.52) )) ||
                skip "Need MDS version at least 2.13.52"
 
        local mdts=$(comma_list $(mdts_nodes))
@@ -19543,6 +19734,15 @@ test_230q() {
                [ $nr_files -eq $total ] ||
                        error "total sub files $nr_files != $total"
        done
+
+       (( MDS1_VERSION >= $(version_code 2.14.51) )) || return 0
+
+       echo "fixed layout directory won't auto split"
+       $LFS migrate -m 0 $DIR/$tdir || error "migrate $tdir failed"
+       wait_update $HOSTNAME "$LFS getdirstripe -H $DIR/$tdir" "crush,fixed" \
+               10 || error "stripe hash $($LFS getdirstripe -H $DIR/$tdir)"
+       wait_update $HOSTNAME "$LFS getdirstripe -c $DIR/$tdir" 1 10 ||
+               error "stripe count $($LFS getdirstripe -c $DIR/$tdir)"
 }
 run_test 230q "dir auto split"
 
@@ -19950,7 +20150,7 @@ run_test 241b "dio vs dio"
 test_242() {
        remote_mds_nodsh && skip "remote MDS with nodsh"
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        touch $DIR/$tdir/$tfile
 
        #define OBD_FAIL_MDS_READPAGE_PACK      0x105
@@ -20142,10 +20342,11 @@ test_247f() {
                grep -q subtree ||
                skip "Fileset feature is not supported"
 
-       mkdir $DIR/$tdir || error "mkdir $tdir failed"
+       mkdir_on_mdt0 $DIR/$tdir || error "mkdir $tdir failed"
        $LFS mkdir -i $((MDSCOUNT - 1)) $DIR/$tdir/remote ||
                error "mkdir remote failed"
-       mkdir $DIR/$tdir/remote/subdir || error "mkdir remote/subdir failed"
+       $LFS mkdir -i $((MDSCOUNT - 1)) $DIR/$tdir/remote/subdir ||
+               error "mkdir remote/subdir failed"
        $LFS mkdir -i 0 -c $MDSCOUNT $DIR/$tdir/striped ||
                error "mkdir striped failed"
        mkdir $DIR/$tdir/striped/subdir || error "mkdir striped/subdir failed"
@@ -20669,6 +20870,7 @@ test_255a() {
                skip "lustre < 2.8.54 does not support ladvise "
        remote_ost_nodsh && skip "remote OST with nodsh"
 
+       stack_trap "rm -f $DIR/$tfile"
        lfs setstripe -c -1 -i 0 $DIR/$tfile || error "$tfile failed"
 
        ladvise_no_type willread $DIR/$tfile &&
@@ -20756,6 +20958,7 @@ test_255b() {
                skip "lustre < 2.8.54 does not support ladvise "
        remote_ost_nodsh && skip "remote OST with nodsh"
 
+       stack_trap "rm -f $DIR/$tfile"
        lfs setstripe -c 1 -i 0 $DIR/$tfile
 
        ladvise_no_type dontneed $DIR/$tfile &&
@@ -20918,7 +21121,7 @@ test_256() {
        changelog_register || error "changelog_register failed"
 
        rm -rf $DIR/$tdir
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
 
        changelog_clear 0 || error "changelog_clear failed"
 
@@ -21069,7 +21272,7 @@ test_270a() {
        local dom=$DIR/$tdir/dom_file
        local tmp=$DIR/$tdir/tmp_file
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
 
        # basic checks for DoM component creation
        $LFS setstripe -E 1024K -E 2048K -L mdt $dom 2>/dev/null &&
@@ -22208,7 +22411,7 @@ test_300c() {
 
        local file_count
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        $LFS setdirstripe -i 0 -c 2 $DIR/$tdir/striped_dir ||
                error "set striped dir error"
 
@@ -22418,7 +22621,7 @@ test_300g() {
        local stripe_count
        local stripe_index
 
-       mkdir $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        mkdir $DIR/$tdir/normal_dir
 
        #Checking when client cache stripe index
@@ -22454,9 +22657,6 @@ test_300g() {
                stripe_count=$($LFS getdirstripe -c $dir)
                [ $stripe_count -eq 0 ] ||
                        error "expect 1 get $stripe_count for $dir"
-               stripe_index=$($LFS getdirstripe -i $dir)
-               [ $stripe_index -eq 0 ] ||
-                       error "expect 0 get $stripe_index for $dir"
        done
 }
 run_test 300g "check default striped directory for normal directory"
@@ -22758,7 +22958,7 @@ test_300p() {
        [ $MDSCOUNT -lt 2 ] && skip_env "needs >= 2 MDTs"
        remote_mds_nodsh && skip "remote MDS with nodsh"
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
 
        #define OBD_FAIL_OUT_ENOSPC     0x1704
        do_facet mds2 lctl set_param fail_loc=0x80001704
@@ -23463,6 +23663,275 @@ test_398f() { #  LU-14687
 }
 run_test 398f "verify aio handles ll_direct_rw_pages errors correctly"
 
+# NB: To get the parallel DIO behavior in LU-13798, there must be > 1
+# stripe and i/o size must be > stripe size
+# Old style synchronous DIO waits after submitting each chunk, resulting in a
+# single RPC in flight.  This test shows async DIO submission is working by
+# showing multiple RPCs in flight.
+test_398g() { #  LU-13798
+       $LFS setstripe -o 0,0 -S 1M $DIR/$tfile
+
+       # We need to do some i/o first to acquire enough grant to put our RPCs
+       # in flight; otherwise a new connection may not have enough grant
+       # available
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=1 oflag=direct ||
+               error "parallel dio failed"
+       stack_trap "rm -f $DIR/$tfile"
+
+       # Reduce RPC size to 1M to avoid combination in to larger RPCs
+       local pages_per_rpc=$($LCTL get_param osc.*-OST0000-*.max_pages_per_rpc)
+       $LCTL set_param osc.*-OST0000-*.max_pages_per_rpc=1M
+       stack_trap "$LCTL set_param -n $pages_per_rpc"
+
+       # Recreate file so it's empty
+       rm -f $DIR/$tfile
+       $LFS setstripe -o 0,0 -S 1M $DIR/$tfile
+       #Pause rpc completion to guarantee we see multiple rpcs in flight
+       #define OBD_FAIL_OST_BRW_PAUSE_BULK
+       do_facet ost1 $LCTL set_param fail_loc=0x214 fail_val=2
+       stack_trap "do_facet ost1 $LCTL set_param fail_loc=0"
+
+       # Clear rpc stats
+       $LCTL set_param osc.*.rpc_stats=c
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=1 oflag=direct ||
+               error "parallel dio failed"
+       stack_trap "rm -f $DIR/$tfile"
+
+       $LCTL get_param osc.*-OST0000-*.rpc_stats
+       pct=$($LCTL get_param osc.*-OST0000-*.rpc_stats |
+               grep -A 8 'rpcs in flight' | grep -v 'rpcs in flight' |
+               grep "8:" | awk '{print $8}')
+       # We look at the "8 rpcs in flight" field, and verify A) it is present
+       # and B) it includes all RPCs.  This proves we had 8 RPCs in flight,
+       # as expected for an 8M DIO to a file with 1M stripes.
+       [ $pct -eq 100 ] || error "we should see 8 RPCs in flight"
+
+       # Verify turning off parallel dio works as expected
+       # Clear rpc stats
+       $LCTL set_param osc.*.rpc_stats=c
+       $LCTL set_param llite.*.parallel_dio=0
+       stack_trap '$LCTL set_param llite.*.parallel_dio=1'
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=1 oflag=direct ||
+               error "dio with parallel dio disabled failed"
+
+       # Ideally, we would see only one RPC in flight here, but there is an
+       # unavoidable race between i/o completion and RPC in flight counting,
+       # so while only 1 i/o is in flight at a time, the RPC in flight counter
+       # will sometimes exceed 1 (3 or 4 is not rare on VM testing).
+       # So instead we just verify it's always < 8.
+       $LCTL get_param osc.*-OST0000-*.rpc_stats
+       ret=$($LCTL get_param osc.*-OST0000-*.rpc_stats |
+               grep -A 8 'rpcs in flight' | grep -v 'rpcs in flight' |
+               grep '^$' -B1 | grep . | awk '{print $1}')
+       [ $ret != "8:" ] ||
+               error "we should see fewer than 8 RPCs in flight (saw $ret)"
+}
+run_test 398g "verify parallel dio async RPC submission"
+
+test_398h() { #  LU-13798
+       local dio_file=$DIR/$tfile.dio
+
+       $LFS setstripe -C 2 -S 1M $DIR/$tfile $dio_file
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct
+       stack_trap "rm -f $DIR/$tfile $dio_file"
+
+       dd if=$DIR/$tfile of=$dio_file bs=8M count=8 iflag=direct oflag=direct ||
+               error "parallel dio failed"
+       diff $DIR/$tfile $dio_file
+       [[ $? == 0 ]] || error "file diff after aiocp"
+}
+run_test 398h "verify correctness of read & write with i/o size >> stripe size"
+
+test_398i() { #  LU-13798
+       local dio_file=$DIR/$tfile.dio
+
+       $LFS setstripe -C 2 -S 1M $DIR/$tfile $dio_file
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct
+       stack_trap "rm -f $DIR/$tfile $dio_file"
+
+       #define OBD_FAIL_LLITE_PAGE_ALLOC 0x1418
+       $LCTL set_param fail_loc=0x1418
+       # make sure we don't crash and fail properly
+       dd if=$DIR/$tfile of=$dio_file bs=8M count=8 iflag=direct oflag=direct &&
+               error "parallel dio page allocation failure succeeded"
+       diff $DIR/$tfile $dio_file
+       [[ $? != 0 ]] || error "no diff after failed aiocp"
+}
+run_test 398i "verify parallel dio handles ll_direct_rw_pages errors correctly"
+
+test_398j() { #  LU-13798
+       # Stripe size > RPC size but less than i/o size tests split across
+       # stripes and RPCs for individual i/o op
+       $LFS setstripe -o 0,0 -S 4M $DIR/$tfile $DIR/$tfile.2
+
+       # Reduce RPC size to 1M to guarantee split to multiple RPCs per stripe
+       local pages_per_rpc=$($LCTL get_param osc.*-OST0000-*.max_pages_per_rpc)
+       $LCTL set_param osc.*-OST0000-*.max_pages_per_rpc=1M
+       stack_trap "$LCTL set_param -n $pages_per_rpc"
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct ||
+               error "parallel dio write failed"
+       stack_trap "rm -f $DIR/$tfile $DIR/$tfile.2"
+
+       dd if=$DIR/$tfile of=$DIR/$tfile.2 bs=8M count=8 iflag=direct ||
+               error "parallel dio read failed"
+       diff $DIR/$tfile $DIR/$tfile.2
+       [[ $? == 0 ]] || error "file diff after parallel dio read"
+}
+run_test 398j "test parallel dio where stripe size > rpc_size"
+
+test_398k() { #  LU-13798
+       wait_delete_completed
+       wait_mds_ost_sync
+
+       # 4 stripe file; we will cause out of space on OST0
+       $LFS setstripe -o 0,1,0,1 -S 1M $DIR/$tfile
+
+       # Fill OST0 (if it's not too large)
+       ORIGFREE=$($LCTL get_param -n lov.$FSNAME-clilov-*.kbytesavail |
+                  head -n1)
+       if [[ $ORIGFREE -gt $MAXFREE ]]; then
+               skip "$ORIGFREE > $MAXFREE skipping out-of-space test on OST0"
+       fi
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile.1
+       dd if=/dev/zero of=$DIR/$tfile.1 bs=1024 count=$MAXFREE &&
+               error "dd should fill OST0"
+       stack_trap "rm -f $DIR/$tfile.1"
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct
+       err=$?
+
+       ls -la $DIR/$tfile
+       $CHECKSTAT -t file -s 0 $DIR/$tfile ||
+               error "file is not 0 bytes in size"
+
+       # dd above should not succeed, but don't error until here so we can
+       # get debug info above
+       [[ $err != 0 ]] ||
+               error "parallel dio write with enospc succeeded"
+       stack_trap "rm -f $DIR/$tfile"
+}
+run_test 398k "test enospc on first stripe"
+
+test_398l() { #  LU-13798
+       wait_delete_completed
+       wait_mds_ost_sync
+
+       # 4 stripe file; we will cause out of space on OST0
+       # Note the 1M stripe size and the > 1M i/o size mean this ENOSPC
+       # happens on the second i/o chunk we issue
+       $LFS setstripe -o 1,0,1,0 -S 1M $DIR/$tfile $DIR/$tfile.2
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=2 oflag=direct
+       stack_trap "rm -f $DIR/$tfile"
+
+       # Fill OST0 (if it's not too large)
+       ORIGFREE=$($LCTL get_param -n lov.$FSNAME-clilov-*.kbytesavail |
+                  head -n1)
+       if [[ $ORIGFREE -gt $MAXFREE ]]; then
+               skip "$ORIGFREE > $MAXFREE skipping out-of-space test on OST0"
+       fi
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile.1
+       dd if=/dev/zero of=$DIR/$tfile.1 bs=1024 count=$MAXFREE &&
+               error "dd should fill OST0"
+       stack_trap "rm -f $DIR/$tfile.1"
+
+       dd if=$DIR/$tfile of=$DIR/$tfile.2 bs=8M count=8 oflag=direct
+       err=$?
+       stack_trap "rm -f $DIR/$tfile.2"
+
+       # Check that short write completed as expected
+       ls -la $DIR/$tfile.2
+       $CHECKSTAT -t file -s 1048576 $DIR/$tfile.2 ||
+               error "file is not 1M in size"
+
+       # dd above should not succeed, but don't error until here so we can
+       # get debug info above
+       [[ $err != 0 ]] ||
+               error "parallel dio write with enospc succeeded"
+
+       # Truncate source file to same length as output file and diff them
+       $TRUNCATE $DIR/$tfile 1048576
+       diff $DIR/$tfile $DIR/$tfile.2
+       [[ $? == 0 ]] || error "data incorrect after short write"
+}
+run_test 398l "test enospc on intermediate stripe/RPC"
+
+test_398m() { #  LU-13798
+       $LFS setstripe -o 0,1,0,1 -S 1M $DIR/$tfile
+
+       # Set up failure on OST0, the first stripe:
+       #define OBD_FAIL_OST_BRW_WRITE_BULK     0x20e
+       #NB: Fail val is ost # + 1, because we cannot use cfs_fail_val = 0
+       # So this fail_val specifies OST0
+       do_facet ost1 $LCTL set_param fail_loc=0x20e fail_val=1
+       stack_trap "do_facet ost1 $LCTL set_param fail_loc=0"
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct &&
+               error "parallel dio write with failure on first stripe succeeded"
+       stack_trap "rm -f $DIR/$tfile"
+       do_facet ost1 $LCTL set_param fail_loc=0 fail_val=0
+
+       # Place data in file for read
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct ||
+               error "parallel dio write failed"
+
+       # Fail read on OST0, first stripe
+       #define OBD_FAIL_OST_BRW_READ_BULK       0x20f
+       do_facet ost1 $LCTL set_param fail_loc=0x20f fail_val=1
+       dd if=$DIR/$tfile of=$DIR/$tfile.2 bs=8M count=8 iflag=direct &&
+               error "parallel dio read with error on first stripe succeeded"
+       rm -f $DIR/$tfile.2
+       do_facet ost1 $LCTL set_param fail_loc=0 fail_val=0
+
+       # Switch to testing on OST1, second stripe
+       # Clear file contents, maintain striping
+       echo > $DIR/$tfile
+       # Set up failure on OST1, second stripe:
+       do_facet ost1 $LCTL set_param fail_loc=0x20e fail_val=2
+       stack_trap "do_facet ost1 $LCTL set_param fail_loc=0"
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct &&
+               error "parallel dio write with failure on first stripe succeeded"
+       stack_trap "rm -f $DIR/$tfile"
+       do_facet ost1 $LCTL set_param fail_loc=0 fail_val=0
+
+       # Place data in file for read
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 oflag=direct ||
+               error "parallel dio write failed"
+
+       # Fail read on OST1, second stripe
+       #define OBD_FAIL_OST_BRW_READ_BULK       0x20f
+       do_facet ost2 $LCTL set_param fail_loc=0x20f fail_val=2
+       dd if=$DIR/$tfile of=$DIR/$tfile.2 bs=8M count=8 iflag=direct &&
+               error "parallel dio read with error on first stripe succeeded"
+       rm -f $DIR/$tfile.2
+       do_facet ost2 $LCTL set_param fail_loc=0 fail_val=0
+}
+run_test 398m "test RPC failures with parallel dio"
+
+# Parallel submission of DIO should not cause problems for append, but it's
+# important to verify.
+test_398n() { #  LU-13798
+       $LFS setstripe -C 2 -S 1M $DIR/$tfile
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=8M count=8 ||
+               error "dd to create source file failed"
+       stack_trap "rm -f $DIR/$tfile"
+
+       dd if=$DIR/$tfile of=$DIR/$tfile.1 bs=8M count=8 oflag=direct oflag=append ||
+               error "parallel dio write with failure on second stripe succeeded"
+       stack_trap "rm -f $DIR/$tfile $DIR/$tfile.1"
+       diff $DIR/$tfile $DIR/$tfile.1
+       [[ $? == 0 ]] || error "data incorrect after append"
+
+}
+run_test 398n "test append with parallel DIO"
+
 test_fake_rw() {
        local read_write=$1
        if [ "$read_write" = "write" ]; then
@@ -23605,7 +24074,6 @@ test_401a() { #LU-7437
        #count the number of parameters by "list_param -R"
        local params=$($LCTL list_param -R '*' 2>/dev/null | wc -l)
        #count the number of parameters by listing proc files
-       local proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
        local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
        echo "proc_dirs='$proc_dirs'"
        [ -n "$proc_dirs" ] || error "no proc_dirs on $HOSTNAME"
@@ -23716,6 +24184,15 @@ test_401d() {
 }
 run_test 401d "Verify 'lctl set_param' accepts values containing '='"
 
+test_401e() { # LU-14779
+       $LCTL list_param -R "ldlm.namespaces.MGC*" ||
+               error "lctl list_param MGC* failed"
+       $LCTL get_param "ldlm.namespaces.MGC*" || error "lctl get_param failed"
+       $LCTL get_param "ldlm.namespaces.MGC*.lru_size" ||
+               error "lctl get_param lru_size failed"
+}
+run_test 401e "verify 'lctl get_param' works with NID in parameter"
+
 test_402() {
        [[ $MDS1_VERSION -ge $(version_code 2.7.66) ]] ||
        [[ $MDS1_VERSION -ge $(version_code 2.7.18.4) &&
@@ -24022,6 +24499,76 @@ test_412() {
 }
 run_test 412 "mkdir on specific MDTs"
 
+generate_uneven_mdts() {
+       local threshold=$1
+       local ffree
+       local bavail
+       local max
+       local min
+       local max_index
+       local min_index
+       local tmp
+       local i
+
+       echo
+       echo "Check for uneven MDTs: "
+
+       ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.filesfree))
+       bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.kbytesavail))
+       bsize=$(lctl get_param -n mdc.*MDT0000*.blocksize)
+
+       max=$(((${ffree[0]} >> 8) * (${bavail[0]} * bsize >> 16)))
+       min=$(((${ffree[0]} >> 8) * (${bavail[0]} * bsize >> 16)))
+       max_index=0
+       min_index=0
+       for ((i = 1; i < ${#ffree[@]}; i++)); do
+               tmp=$(((${ffree[i]} >> 8) * (${bavail[i]} * bsize >> 16)))
+               if [ $tmp -gt $max ]; then
+                       max=$tmp
+                       max_index=$i
+               fi
+               if [ $tmp -lt $min ]; then
+                       min=$tmp
+                       min_index=$i
+               fi
+       done
+
+       # Check if we need to generate uneven MDTs
+       local diff=$(((max - min) * 100 / min))
+       local testdir=$DIR/$tdir-fillmdt
+
+       mkdir -p $testdir
+
+       i=0
+       while (( diff < threshold )); do
+               # generate uneven MDTs, create till $threshold% diff
+               echo -n "weight diff=$diff% must be > $threshold% ..."
+               echo "Fill MDT$min_index with 100 files: loop $i"
+               testdir=$DIR/$tdir-fillmdt/$i
+               [ -d $testdir ] || $LFS mkdir -i $min_index $testdir ||
+                       error "mkdir $testdir failed"
+               $LFS setstripe -E 1M -L mdt $testdir ||
+                       error "setstripe $testdir failed"
+               for F in f.{0..99}; do
+                       dd if=/dev/zero of=$testdir/$F bs=1M count=1 > \
+                               /dev/null 2>&1 || error "dd $F failed"
+               done
+
+               ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-*.filesfree))
+               bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-*.kbytesavail))
+               max=$(((${ffree[max_index]} >> 8) * \
+                       (${bavail[max_index]} * bsize >> 16)))
+               min=$(((${ffree[min_index]} >> 8) * \
+                       (${bavail[min_index]} * bsize >> 16)))
+               diff=$(((max - min) * 100 / min))
+               i=$((i + 1))
+       done
+
+       echo "MDT filesfree available: ${ffree[@]}"
+       echo "MDT blocks available: ${bavail[@]}"
+       echo "weight diff=$diff%"
+}
+
 test_qos_mkdir() {
        local mkdir_cmd=$1
        local stripe_count=$2
@@ -24044,11 +24591,11 @@ test_qos_mkdir() {
        lmv_qos_threshold_rr=${lmv_qos_threshold_rr%%%}
        lmv_qos_maxage=$($LCTL get_param -n lmv.*.qos_maxage)
        stack_trap "$LCTL set_param \
-               lmv.*.qos_prio_free=$lmv_qos_prio_free > /dev/null" EXIT
+               lmv.*.qos_prio_free=$lmv_qos_prio_free > /dev/null"
        stack_trap "$LCTL set_param \
-               lmv.*.qos_threshold_rr=$lmv_qos_threshold_rr > /dev/null" EXIT
+               lmv.*.qos_threshold_rr=$lmv_qos_threshold_rr > /dev/null"
        stack_trap "$LCTL set_param \
-               lmv.*.qos_maxage=$lmv_qos_maxage > /dev/null" EXIT
+               lmv.*.qos_maxage=$lmv_qos_maxage > /dev/null"
 
        lod_qos_prio_free=$(do_facet mds1 $LCTL get_param -n \
                lod.$FSNAME-MDT0000-mdtlov.mdt_qos_prio_free | head -n1)
@@ -24059,12 +24606,11 @@ test_qos_mkdir() {
        lod_qos_maxage=$(do_facet mds1 $LCTL get_param -n \
                lod.$FSNAME-MDT0000-mdtlov.qos_maxage | awk '{ print $1 }')
        stack_trap "do_nodes $mdts $LCTL set_param \
-               lod.*.mdt_qos_prio_free=$lod_qos_prio_free > /dev/null" EXIT
+               lod.*.mdt_qos_prio_free=$lod_qos_prio_free > /dev/null"
        stack_trap "do_nodes $mdts $LCTL set_param \
-               lod.*.mdt_qos_threshold_rr=$lod_qos_threshold_rr > /dev/null" \
-               EXIT
+               lod.*.mdt_qos_threshold_rr=$lod_qos_threshold_rr > /dev/null"
        stack_trap "do_nodes $mdts $LCTL set_param \
-               lod.*.mdt_qos_maxage=$lod_qos_maxage > /dev/null" EXIT
+               lod.*.mdt_qos_maxage=$lod_qos_maxage > /dev/null"
 
        $LCTL set_param lmv.*.qos_threshold_rr=100 > /dev/null
        do_nodes $mdts $LCTL set_param lod.*.mdt_qos_threshold_rr=100 > /dev/null
@@ -24074,11 +24620,12 @@ test_qos_mkdir() {
        local stripe_index=$($LFS getstripe -m $testdir)
        local test_mkdir_rr=true
 
-       getfattr -d -m dmv $testdir | grep dmv
-       if [ $? -eq 0 ] && [ $MDS1_VERSION -ge $(version_code 2.14.51) ]; then
-               local inherit_rr=$($LFS getdirstripe -D --max-inherit-rr $testdir)
-
-               (( $inherit_rr == 0 )) && test_mkdir_rr=false
+       echo "dirstripe: '$($LFS getdirstripe $testdir)'"
+       getfattr -d -m dmv -e hex $testdir | grep dmv
+       if (( $? == 0 && $MDS1_VERSION >= $(version_code 2.14.51) )); then
+               echo "defstripe: '$($LFS getdirstripe -D $testdir)'"
+               (( $($LFS getdirstripe -D --max-inherit-rr $testdir) == 0 )) &&
+                       test_mkdir_rr=false
        fi
 
        echo
@@ -24086,41 +24633,37 @@ test_qos_mkdir() {
                echo "Mkdir (stripe_count $stripe_count) roundrobin:" ||
                echo "Mkdir (stripe_count $stripe_count) on stripe $stripe_index"
 
-       for i in $(seq $((100 * MDSCOUNT))); do
+       stack_trap "unlinkmany -d $testdir/subdir $((100 * MDSCOUNT))"
+       for (( i = 0; i < 100 * MDSCOUNT; i++ )); do
                eval $mkdir_cmd $testdir/subdir$i ||
                        error "$mkdir_cmd subdir$i failed"
        done
 
-       for i in $(seq $MDSCOUNT); do
-               count=$($LFS getdirstripe -i $testdir/* |
-                               grep ^$((i - 1))$ | wc -l)
-               echo "$count directories created on MDT$((i - 1))"
+       for (( i = 0; i < $MDSCOUNT; i++ )); do
+               count=$($LFS getdirstripe -i $testdir/* | grep -c "^$i$")
+               echo "$count directories created on MDT$i"
                if $test_mkdir_rr; then
                        (( $count == 100 )) ||
                                error "subdirs are not evenly distributed"
-               elif [ $((i - 1)) -eq $stripe_index ]; then
+               elif (( $i == $stripe_index )); then
                        (( $count == 100 * MDSCOUNT )) ||
-                               error "$count subdirs created on MDT$((i - 1))"
+                               error "$count subdirs created on MDT$i"
                else
                        (( $count == 0 )) ||
-                               error "$count subdirs created on MDT$((i - 1))"
+                               error "$count subdirs created on MDT$i"
                fi
 
                if $test_mkdir_rr && [ $stripe_count -gt 1 ]; then
                        count=$($LFS getdirstripe $testdir/* |
-                               grep -P "^\s+$((i - 1))\t" | wc -l)
-                       echo "$count stripes created on MDT$((i - 1))"
+                               grep -c -P "^\s+$i\t")
+                       echo "$count stripes created on MDT$i"
                        # deviation should < 5% of average
-                       (( $count < 95 * stripe_count )) ||
-                       (( $count > 105 * stripe_count)) &&
+                       (( $count >= 95 * stripe_count &&
+                          $count <= 105 * stripe_count)) ||
                                error "stripes are not evenly distributed"
                fi
        done
 
-       $LCTL set_param lmv.*.qos_threshold_rr=$lmv_qos_threshold_rr > /dev/null
-       do_nodes $mdts $LCTL set_param \
-               lod.*.mdt_qos_threshold_rr=$lod_qos_threshold_rr > /dev/null
-
        echo
        echo "Check for uneven MDTs: "
 
@@ -24152,47 +24695,20 @@ test_qos_mkdir() {
                fi
        done
 
-       (( ${ffree[min_index]} == 0 )) &&
+       (( ${ffree[min_index]} > 0 )) ||
                skip "no free files in MDT$min_index"
-       (( ${ffree[min_index]} > 100000000 )) &&
+       (( ${ffree[min_index]} < 100000000 )) ||
                skip "too many free files in MDT$min_index"
 
-       # Check if we need to generate uneven MDTs
-       local threshold=50
-       local diff=$(((max - min) * 100 / min))
-       local value="$(generate_string 1024)"
-
-       while [ $diff -lt $threshold ]; do
-               # generate uneven MDTs, create till $threshold% diff
-               echo -n "weight diff=$diff% must be > $threshold% ..."
-               count=$((${ffree[min_index]} / 10))
-               # 50 sec per 10000 files in vm
-               (( $count < 100000 )) || [ "$SLOW" != "no" ] ||
-                       skip "$count files to create"
-               echo "Fill MDT$min_index with $count files"
-               [ -d $DIR/$tdir-MDT$min_index ] ||
-                       $LFS mkdir -i $min_index $DIR/$tdir-MDT$min_index ||
-                       error "mkdir $tdir-MDT$min_index failed"
-               createmany -d $DIR/$tdir-MDT$min_index/d $count ||
-                       error "create d$count failed"
-
-               ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-*.filesfree))
-               bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-*.kbytesavail))
-               max=$(((${ffree[max_index]} >> 8) * \
-                       (${bavail[max_index]} * bsize >> 16)))
-               min=$(((${ffree[min_index]} >> 8) * \
-                       (${bavail[min_index]} * bsize >> 16)))
-               diff=$(((max - min) * 100 / min))
-       done
-
        echo "MDT filesfree available: ${ffree[@]}"
        echo "MDT blocks available: ${bavail[@]}"
-       echo "weight diff=$diff%"
-
+       echo "weight diff=$(((max - min) * 100 / min))%"
        echo
        echo "Mkdir (stripe_count $stripe_count) with balanced space usage:"
 
+       $LCTL set_param lmv.*.qos_threshold_rr=0 > /dev/null
        $LCTL set_param lmv.*.qos_prio_free=100 > /dev/null
+       do_nodes $mdts $LCTL set_param lod.*.mdt_qos_threshold_rr=0 > /dev/null
        do_nodes $mdts $LCTL set_param lod.*.mdt_qos_prio_free=100 > /dev/null
        # decrease statfs age, so that it can be updated in time
        $LCTL set_param lmv.*.qos_maxage=1 > /dev/null
@@ -24201,42 +24717,65 @@ test_qos_mkdir() {
        sleep 1
 
        testdir=$DIR/$tdir-s$stripe_count/qos
+       local num=200
 
-       for i in $(seq $((100 * MDSCOUNT))); do
+       stack_trap "unlinkmany -d $testdir/subdir $((num * MDSCOUNT))"
+       for (( i = 0; i < num * MDSCOUNT; i++ )); do
                eval $mkdir_cmd $testdir/subdir$i ||
                        error "$mkdir_cmd subdir$i failed"
        done
 
-       for i in $(seq $MDSCOUNT); do
-               count=$($LFS getdirstripe -i $testdir/* | grep ^$((i - 1))$ |
-                       wc -l)
-               echo "$count directories created on MDT$((i - 1))"
+       for (( i = 0; i < $MDSCOUNT; i++ )); do
+               count=$($LFS getdirstripe -i $testdir/* | grep -c "^$i$")
+               echo "$count directories created on MDT$i"
 
                if [ $stripe_count -gt 1 ]; then
                        count=$($LFS getdirstripe $testdir/* |
-                               grep -P "^\s+$((i - 1))\t" | wc -l)
-                       echo "$count stripes created on MDT$((i - 1))"
+                               grep -c -P "^\s+$i\t")
+                       echo "$count stripes created on MDT$i"
                fi
        done
 
-       max=$($LFS getdirstripe -i $testdir/* | grep ^$max_index$ | wc -l)
-       min=$($LFS getdirstripe -i $testdir/* | grep ^$min_index$ | wc -l)
+       max=$($LFS getdirstripe -i $testdir/* | grep -c "^$max_index$")
+       min=$($LFS getdirstripe -i $testdir/* | grep -c "^$min_index$")
 
        # D-value should > 10% of averge
-       (( $max - $min < 10 )) &&
-               error "subdirs shouldn't be evenly distributed"
+       (( max - min >= num / 10 )) ||
+               error "subdirs shouldn't be evenly distributed: $max - $min < $((num / 10))"
 
-       # ditto
-       if [ $stripe_count -gt 1 ]; then
+       # 5% for stripes
+       if (( stripe_count > 1 )); then
                max=$($LFS getdirstripe $testdir/* |
-                       grep -P "^\s+$max_index\t" | wc -l)
+                     grep -c -P "^\s+$max_index\t")
                min=$($LFS getdirstripe $testdir/* |
-                       grep -P "^\s+$min_index\t" | wc -l)
-               (( $max - $min < 10 * $stripe_count )) &&
-                       error "stripes shouldn't be evenly distributed"|| true
+                       grep -c -P "^\s+$min_index\t")
+               (( max - min >= num * stripe_count / 20 )) ||
+                       error "stripes shouldn't be evenly distributed: $max - $min < $((num / 20)) * $stripe_count"
        fi
 }
 
+most_full_mdt() {
+       local ffree
+       local bavail
+       local bsize
+       local min
+       local min_index
+       local tmp
+
+       ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.filesfree))
+       bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.kbytesavail))
+       bsize=$(lctl get_param -n mdc.*MDT0000*.blocksize)
+
+       min=$(((${ffree[0]} >> 8) * (${bavail[0]} * bsize >> 16)))
+       min_index=0
+       for ((i = 1; i < ${#ffree[@]}; i++)); do
+               tmp=$(((${ffree[i]} >> 8) * (${bavail[i]} * bsize >> 16)))
+               (( tmp < min )) && min=$tmp && min_index=$i
+       done
+
+       echo -n $min_index
+}
+
 test_413a() {
        [ $MDSCOUNT -lt 2 ] &&
                skip "We need at least 2 MDTs for this test"
@@ -24246,11 +24785,13 @@ test_413a() {
 
        local stripe_count
 
+       generate_uneven_mdts 100
        for stripe_count in $(seq 1 $((MDSCOUNT - 1))); do
                mkdir $DIR/$tdir-s$stripe_count || error "mkdir failed"
                mkdir $DIR/$tdir-s$stripe_count/rr || error "mkdir failed"
-               mkdir $DIR/$tdir-s$stripe_count/qos || error "mkdir failed"
-               test_qos_mkdir "$LFS mkdir -c $stripe_count" $stripe_count
+               $LFS mkdir -i $(most_full_mdt) $DIR/$tdir-s$stripe_count/qos ||
+                       error "mkdir failed"
+               test_qos_mkdir "$LFS mkdir -i -1 -c $stripe_count" $stripe_count
        done
 }
 run_test 413a "QoS mkdir with 'lfs mkdir -i -1'"
@@ -24265,11 +24806,13 @@ test_413b() {
        local testdir
        local stripe_count
 
+       generate_uneven_mdts 100
        for stripe_count in $(seq 1 $((MDSCOUNT - 1))); do
                testdir=$DIR/$tdir-s$stripe_count
                mkdir $testdir || error "mkdir $testdir failed"
                mkdir $testdir/rr || error "mkdir rr failed"
-               mkdir $testdir/qos || error "mkdir qos failed"
+               $LFS mkdir -i $(most_full_mdt) $testdir/qos ||
+                       error "mkdir qos failed"
                $LFS setdirstripe -D -c $stripe_count --max-inherit-rr 2 \
                        $testdir/rr || error "setdirstripe rr failed"
                $LFS setdirstripe -D -c $stripe_count $testdir/qos ||
@@ -24280,11 +24823,11 @@ test_413b() {
 run_test 413b "QoS mkdir under dir whose default LMV starting MDT offset is -1"
 
 test_413c() {
-       [ $MDSCOUNT -ge 2 ] ||
+       (( $MDSCOUNT >= 2 )) ||
                skip "We need at least 2 MDTs for this test"
 
-       [ $MDS1_VERSION -ge $(version_code 2.14.51) ] ||
-               skip "Need server version at least 2.14.50"
+       (( $MDS1_VERSION >= $(version_code 2.14.51) )) ||
+               skip "Need server version at least 2.14.51"
 
        local testdir
        local inherit
@@ -24293,11 +24836,11 @@ test_413c() {
        testdir=$DIR/${tdir}-s1
        mkdir $testdir || error "mkdir $testdir failed"
        mkdir $testdir/rr || error "mkdir rr failed"
-       mkdir $testdir/qos || error "mkdir qos failed"
+       $LFS mkdir -i $(most_full_mdt) $testdir/qos || error "mkdir qos failed"
        # default max_inherit is -1, default max_inherit_rr is 0
        $LFS setdirstripe -D -c 1 $testdir/rr ||
                error "setdirstripe rr failed"
-       $LFS setdirstripe -D -c 1 -X 2 --max-inherit-rr 1 $testdir/qos ||
+       $LFS setdirstripe -D -c 1 -i -1 -X 2 --max-inherit-rr 1 $testdir/qos ||
                error "setdirstripe qos failed"
        test_qos_mkdir "mkdir" 1
 
@@ -24305,21 +24848,35 @@ test_413c() {
        inherit=$($LFS getdirstripe -D -X $testdir/rr/level1)
        (( $inherit == -1 )) || error "rr/level1 inherit $inherit != -1"
        inherit_rr=$($LFS getdirstripe -D --max-inherit-rr $testdir/rr/level1)
-       (( $inherit_rr == 0 )) ||
-               error "rr/level1 inherit-rr $inherit_rr != 0"
+       (( $inherit_rr == 0 )) || error "rr/level1 inherit-rr $inherit_rr != 0"
 
        mkdir $testdir/qos/level1 || error "mkdir qos/level1 failed"
        inherit=$($LFS getdirstripe -D -X $testdir/qos/level1)
        (( $inherit == 1 )) || error "qos/level1 inherit $inherit != 1"
        inherit_rr=$($LFS getdirstripe -D --max-inherit-rr $testdir/qos/level1)
-       (( $inherit_rr == 0 )) ||
-               error "qos/level1 inherit-rr $inherit_rr !=0"
+       (( $inherit_rr == 0 )) || error "qos/level1 inherit-rr $inherit_rr != 0"
        mkdir $testdir/qos/level1/level2 || error "mkdir level2 failed"
-       getfattr -d -m dmv $testdir/qos/level1/level2 | grep dmv &&
+       getfattr -d -m dmv -e hex $testdir/qos/level1/level2 | grep dmv &&
                error "level2 shouldn't have default LMV" || true
 }
 run_test 413c "mkdir with default LMV max inherit rr"
 
+test_413z() {
+       local pids=""
+       local subdir
+       local pid
+
+       for subdir in $(\ls -1 -d $DIR/d413*-fillmdt/*); do
+               unlinkmany $subdir/f. 100 &
+               pids="$pids $!"
+       done
+
+       for pid in $pids; do
+               wait $pid
+       done
+}
+run_test 413z "413 test cleanup"
+
 test_414() {
 #define OBD_FAIL_PTLRPC_BULK_ATTACH      0x521
        $LCTL set_param fail_loc=0x80000521
@@ -25247,6 +25804,38 @@ test_431() { # LU-14187
 }
 run_test 431 "Restart transaction for IO"
 
+cleanup_test_432() {
+       do_facet mgs $LCTL nodemap_activate 0
+       wait_nm_sync active
+}
+
+test_432() {
+       local tmpdir=$TMP/dir432
+
+       (( $MDS1_VERSION >= $(version_code 2.14.52) )) ||
+               skip "Need MDS version at least 2.14.52"
+
+       stack_trap cleanup_test_432 EXIT
+       mkdir $DIR/$tdir
+       mkdir $tmpdir
+
+       do_facet mgs $LCTL nodemap_activate 1
+       wait_nm_sync active
+       do_facet mgs $LCTL nodemap_modify --name default \
+               --property admin --value 1
+       do_facet mgs $LCTL nodemap_modify --name default \
+               --property trusted --value 1
+       cancel_lru_locks mdc
+       wait_nm_sync default admin_nodemap
+       wait_nm_sync default trusted_nodemap
+
+       if [ $(mv $tmpdir $DIR/$tdir/ 2>&1 |
+              grep -ci "Operation not permitted") -ne 0 ]; then
+               error "mv $tmpdir $DIR/$tdir/ hits 'Operation not permitted'"
+       fi
+}
+run_test 432 "mv dir from outside Lustre"
+
 prep_801() {
        [[ $MDS1_VERSION -lt $(version_code 2.9.55) ]] ||
        [[ $OST1_VERSION -lt $(version_code 2.9.55) ]] &&
@@ -25560,7 +26149,7 @@ test_803a() {
        [ $MDS1_VERSION -lt $(version_code 2.10.54) ] &&
                skip "MDS needs to be newer than 2.10.54"
 
-       mkdir -p $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        # Create some objects on all MDTs to trigger related logs objects
        for idx in $(seq $MDSCOUNT); do
                $LFS mkdir -c $MDSCOUNT -i $((idx % $MDSCOUNT)) \
@@ -25755,7 +26344,7 @@ test_805() {
        fi
        do_facet $SINGLEMDS zfs set quota=$(((usedkb+freekb)*1024)) $fsset
        trap cleanup_805 EXIT
-       mkdir $DIR/$tdir
+       mkdir_on_mdt0 $DIR/$tdir
        $LFS setstripe -E 1M -c2 -E 4M -c2 -E -1 -c2 $DIR/$tdir ||
                error "Can't set PFL layout"
        createmany -m $DIR/$tdir/f- 1000000 && error "ENOSPC wasn't met"
@@ -25903,7 +26492,7 @@ test_807() {
        stack_trap "restore_lustre_params < $save; rm -f $save" EXIT
 
        rm -rf $DIR/$tdir || error "rm $tdir failed"
-       mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       mkdir_on_mdt0 $DIR/$tdir || error "mkdir $tdir failed"
        touch $DIR/$tdir/trunc || error "touch $tdir/trunc failed"
        $TRUNCATE $DIR/$tdir/trunc 1024 || error "truncate $tdir/trunc failed"
        $TRUNCATE $DIR/$tdir/trunc 1048576 ||